#!/bin/bash
#
###########################################################
#
# (C) Copyright IBM Corporation 2007.
#       Released under GPL v2.
#       Author : Donjuma Lee (donslee@us.ibm.com)
#
# VERSION: 2.02
#
# contributions from Joel Diaz (joeldiaz@us.ibm.com)
#
###########################################################

# driver tool path
DRVTL_PATH="/usr/local/bin"
# ensure a working PATH
export PATH=/bin:/usr/bin:${DRVTL_PATH}:$PATH

# CHECK FOR SUPPORT FOLDER

if [ ! -d /var/log/IBM_Support ];then
  mkdir -p /var/log/IBM_Support
fi

# count errors
ERROR_COUNT=0

# locatin of the installer rpm
TOOL_DIR="tools"

# set the application directory
APPS_DIR="apps"

INSTALLER_PATH="$(dirname $0)"
cd $INSTALLER_PATH 2> /dev/null

# find the path and count the installer rpm
TOOLDIR="$PWD/tools/"
PATH="$PATH:$TOOLDIR"

# installer setup
IBM_DRVTL="./tools/ibm-driver-tool.pl"
INSTALL_OPTIONS="--yes $@"

# basic package health checks
if [ ${ERROR_COUNT} -gt 0 ]
then
	echo -e "Exiting...."
	exit 1
fi


LOG="/var/log/IBM_Support/driver_install.log"
# check current firmware version before driver install
#echo -e "Checking current firmware level" >> $LOG
   
#for intf in `ifconfig -a | grep eth | cut -d' ' -f1`; do
#    if [ `ethtool -i $intf | grep driver | awk '{print $2}'` == "be2net" ]; then
#        FIRMWARE=`ethtool -i $intf | grep -i "firmware-version" | cut -d':' -f2`
#        echo -e "Retrieved Firmware level:${FIRMWARE}" >> $LOG
#        
#        if [[ "$FIRMWARE" == *411* ]] || [[ "$FIRMWARE" == *250* ]];then
#            echo -e "Please update your firmware. Detected:$FIRMWARE" >> $LOG
#            echo -e "If you are at an older fw release, " >> $LOG
#            echo -e "please use the supported driver&kit for your current firmware" >> $LOG 
#            echo -e "to upgrade to latest FW. Then re-run this nic$kit package again." >> $LOG
#            exit 172;fi
#    fi
#done

# install/update the installer
# run the installer with default and user provided options

	${IBM_DRVTL} ${INSTALL_OPTIONS}
	EXIT_CODE=$?
#	if [ -f /etc/redhat-release ] ; then
#		UNAME=$(uname -r)
#		 /sbin/mkinitrd --allow-missing -f /boot/initrd-${UNAME}.img ${UNAME}
#	fi
	

# exit with the installers exit code

# if the package was successfully installed
# install any apps
if [ -d ${APPS_DIR} ] && [ ${EXIT_CODE} -eq 0 ]
then
	if [ $(find ${APPS_DIR} -type f -name \*.rpm 2> /dev/null | wc --l) -gt 0 ]
	then
		echo -e "Applications directory \"${APPS_DIR}\" found, installing included RPMs"
		#find ${APPS_DIR} -type f -name \*.rpm | xargs --replace=file rpm -Uvh file
		LOG="/var/log/IBM_Support/kit_install.log"
		./apps/elx_install.sh /dev/null > $LOG
		RETURN_CODE=$?
		if [ $RETURN_CODE -ne 0 ]; 
                then
                    if [[ $(rpm -qa | grep elxocm) ]];
                    then
                        echo -e "OCM is already installed" >> $LOG 
                    else
                        EXIT_CODE=172;fi
                    
                fi
	fi
fi


exit ${EXIT_CODE}
